<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select
          v-model:value="model[field]"
          placeholder="请选择行业分类"
          :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions"
          @change="changeSuspect"
        ></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select
          v-model:value="model[field]"
          show-search
          placeholder="请选择二级"
          allow-clear
          tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }"
          :tree-data="treeData"
          tree-node-filter-prop="label"
        >
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleView" v-auth="'fxpg-psbtg-jbxx'">查看基本信息</a-button>
        <a-button type="primary" @click="onExportXls" v-auth="'fxpg-psbtg-dc'">导出</a-button>
        <a-button type="primary" @click="handelStep" v-auth="'fxpg-psbtg-lct'">流程图</a-button>
        <a-button type="primary" @click="showDetail" v-auth="'fxpg:bcxx'">补充信息</a-button>
      </template>
      <!--操作栏-->
    </BasicTable>
    <!-- 流程图 -->
    <Step @register="registerlcModal" />
  </div>
</template>

<script lang="ts" name="dkgl-fxpg-Failed" setup>
  import { BasicTable } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { useRouter } from 'vue-router';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useModal } from '/@/components/Modal';
  import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
  import { failedList, getImportUrl, getExportUrl } from './api';
  import Step from '/@/components/customComponent/steps/step.vue';

  let router = useRouter();
  const { createMessage } = useMessage();
  const [registerlcModal, { openModal: openlcModal }] = useModal();
  //注册table数据
  const { tableContext, onExportXls } = useListPage({
    tableProps: {
      title: '风险评估-评审不通过',
      api: failedList,
      columns,
      canResize: false,
      clickToRowSelect: true,
      showActionColumn: false,
      //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
      rowKey: 'wrdkid',
      rowSelection: { type: 'radio' },
      formConfig: {
        labelWidth: 120,
        schemas: [
          ...searchFormSchema,
          {
            label: '阶段内状态',
            field: 'jdnzt',
            component: 'Input',
            defaultValue: 'SHBTG',
            show: false,
          },
        ],
        autoSubmitOnEnter: true,
        showAdvancedButton: false,
      },
    },
    exportConfig: {
      name: '风险评估-评审不通过',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
    },
  });
  const isSuspectOptions = useSuspectsData().data; // 行业分类
  const useCategory = useCategoryData();
  const treeData = useCategory.data; // 行业类别-数据
  const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
  const [registerTable, {}, { rowSelection, selectedRowKeys, selectedRows }] = tableContext;
  // 查看基本信息
  function handleView() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    router.push(`/dkgl/fxpg/ViewDetail?wrdkid=${selectedRowKeys.value[0]}`);
  }

  // 点击查看流程图
  function handelStep() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    openlcModal(true, {
      record: selectedRows.value[0],
      isUpdate: true,
      showFooter: true,
    });
  }
  // 点击补充信息
  async function showDetail() {
    if (selectedRowKeys.value.length == 0) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    
    router.push(`/dkgl/investigate/modal/DataFilling?wrdkid=${selectedRowKeys.value[0]}`);
  }
</script>
<style scoped></style>
